<?php
/*
Plugin Name: Shibuya CMS
Plugin URI: http://heli.otro.pics/shibuya-cms/
Description: カスタム投稿タイプを簡単に登録でき、カスタムフィールドと合わせた投稿画面が作れます。
Author: Takuma Ando
Version: 0.3.16
Author URI: http://heli.otro.pics/
*/


class ShibuyaCMS {
	
	public $files = array();
	
	public function __construct() {
		add_action( 'init', array($this, 'register') );
		add_action( 'init', array($this, 'get_post_image') );
		add_action( 'admin_init', array($this, 'admin_init') );
		add_action( 'admin_menu', array($this, 'admin_menu') );
		add_action( 'add_meta_boxes', array($this, 'add_meta_boxes') );
		add_action( 'save_post', array($this, 'save_post') );
		add_action( 'admin_init', array($this, 'wpeditor_init'), 5 );
	}
	
	
	public function enqueue_script(){
		wp_enqueue_style( 'shibuya-cms',   plugin_dir_url(__FILE__) . 'shibuya-cms.css' );
		wp_enqueue_style( 'jquery-ui-theme',   plugin_dir_url(__FILE__) . 'wp-admin/jquery-ui-theme/jquery-ui.min.css' );
		wp_enqueue_style( 'editor' );
		wp_enqueue_script( 'shibuya-cms', plugin_dir_url(__FILE__) . 'shibuya-cms.js', array(
						'jquery',
						'jquery-ui-core',
						'jquery-ui-datepicker',
						'jquery-ui-sortable',
						'jquery-ui-draggable',
						'jquery-ui-droppable',
						'jquery-ui-selectable' ) );
		/*
		wp_enqueue_script( 'editor' );
		wp_enqueue_script( 'quicktags' );
		wp_enqueue_style( 'buttons' );
		*/
		echo '<script>var shibuyaCmsCustomFields;</script>';
		
		if ( current_user_can( 'upload_files' ) ) {
			if( get_the_ID() ) {
				wp_enqueue_media(array('post'=>get_the_ID()));
			} else {
				wp_enqueue_media();
			}
		}
	}
	
	
	public function admin_menu() {
		add_options_page( 'Shibuya CMS', 'Shibuya CMS', 'manage_options', 'shibuya_cms_plugin_page', array($this, 'plugin_page'));
	}
	
	
	public function plugin_page() {
		if( isset($_GET['pid']) ) {
			include plugin_dir_path( __FILE__ ) . 'wp-admin/edit.php';
		} else {
			include plugin_dir_path( __FILE__ ) . 'wp-admin/index.php';
		}
	}
	
	public function add_meta_boxes(){
		global $post;
		$post_type = !empty( $_GET['post_type'] ) ? $_GET['post_type'] : '';
		if( !empty( $post ) ){
			$post_type = $post->post_type;
		}
		
		$files = $this->get_files();
		if( post_type_exists( $post_type ) ){
			foreach( $files as $file ) {
				if( $file['slug'] == $post_type && !empty($file['form']) ) {
					$post_type = get_post_type_object( $post_type );
					add_meta_box(
						$post_type->name.'-data',
						$post_type->label,
						array($this, 'meta_box_inner'),
						$post_type->name,
						'normal',
						'high',
						array( $post_type )
					);
					break;
				}
			}
		}
	}
	
	public function meta_box_inner( $post, $meta_box ){
		$files = $this->get_files();
		$post_type = $meta_box['args'][0]->name;
		if( post_type_exists( $post_type ) ){
			echo '<div class="shibuya-cms-form">';
			if( $custom_fields = get_post_custom( $post->ID ) )
				echo '<script>shibuyaCmsCustomFields = '.json_encode( $custom_fields ) . '</script>';
			foreach($files as $file) {
				if( $post_type == $file['slug'] ) {
					$form = @$file['form'] ? $file['form'] : @$file['data'];
					$form = preg_replace_callback(
										'/<textarea.*?>.*?<\/textarea>/ism',
										array($this, 'textarea_replace_callback'),
										$form);
					eval('?'.'>'.$form);
				}
			}
			echo '</div>';
		}
	}
	
	
	
	public function save_post( $post_id ){
		if( !empty( $_POST ) ){
			$postdata = array();
			foreach( $_POST as $key => $value ){
				if( substr( $key, 0, 1 ) == '@' ){
					$key = substr( $key, 1 );
					if( ! is_array( $value ) ) {
						update_post_meta( $post_id, $key, $value );
					} else {
						delete_post_meta( $post_id, $key );
						foreach( $value as $v ){
							add_post_meta( $post_id, $key, $v );
						}
					}
				}
			}
		}
	}
	
	
	
	
	public function admin_init() {
		if( !empty($_POST['__shibuya_cms_add_post_type']) || !empty($_POST['__shibuya_cms_edit_post_type']) ) {
			if( !empty($_POST['post_type_slug'])
									&& !empty($_POST['post_type_name'])
									&& preg_match('/^[a-zA-Z0-9\_\-]+$/', $_POST['post_type_slug']) ) {
				$slug = $_POST['post_type_slug'];
				$name = $_POST['post_type_name'];
				
				$files = $this->get_files();
				$bool = true;
				if( !empty($_POST['__shibuya_cms_add_post_type']) ) {
					foreach( $files as $file ) {
						if( $file['slug'] == $slug )
							$bool = false;
					}
				}
				
				if( $bool ) {
					if( !empty($_POST['__shibuya_cms_add_post_type']) ) {
						$pid = md5(time());
						$ini = file_get_contents( plugin_dir_path( __FILE__ ) . 'sample.ini' );
						$form = file_get_contents( plugin_dir_path( __FILE__ ) . 'sample.php' );
						foreach(array('form', 'ini') as $key ) {
							$$key = preg_replace( '/\{\{post_type_name\}\}/', $name, $$key );
							$icon = plugin_dir_url(__FILE__).'wp-admin/img/menu_icon.png';
							$$key = preg_replace( '/\{\{menu_icon\}\}/', parse_url($icon, PHP_URL_PATH), $$key );
						}
					} else {
						$pid = $_GET['pid'];
						$ini = stripslashes($_POST['post_type_ini']);
						$form = stripslashes($_POST['post_type_form']);
					}
					$files[$pid] = compact('slug', 'name', 'ini', 'form');
					update_option('shibuya-cms-files', $files);
				}
			}
			
			wp_redirect($_SERVER['REQUEST_URI'], 302);
			exit;
		}
		
		if( @$_GET['delete'] && @$_GET['pid'] ) {
			$pid = $_GET['pid'];
			$files = $this->get_files();
			unset($files[$pid]);
			update_option('shibuya-cms-files', $files);
			$gets = $_GET;
			unset($gets['pid'], $gets['delete']);
			wp_redirect($_SERVER['PHP_SELF']. '?' .http_build_query($gets), 302);
			exit;
		}
		add_action( 'admin_enqueue_scripts', array($this, 'enqueue_script') );
		
		add_action( 'load-post.php', array($this, 'load') );
		add_action( 'load-post-new.php', array($this, 'load') );
	}
	
	
	public function get_files() {
		if( !$this->files ) {
			if( $this->files = get_option('shibuya-cms-files') ) {
				foreach( array_keys($this->files) as $idx ) {
					$this->files[$idx]['config'] = $this->parse_ini($this->files[$idx]['ini']);
				}
			} else {
				$this->files = array();
			}
		}
		return $this->files;
	}
	
	
	public function manage_posts_columns( $columns ){
		if( !empty( $GLOBALS['shown-metas'] ) ){
			foreach( $GLOBALS['shown-metas'] as $key => $value ){
				$columns[ $key ] = $value;
			}
			return $columns;
		}
	}
	public function manage_posts_custom_column( $column_name, $post_id ){
		if( isset( $GLOBALS['shown-metas'][ $column_name ] ) ){
			if( $values = get_post_meta( $post_id, $column_name ) )
				echo join( $values, ', ');
			else
				echo __('None');
		}
	}
	
	
	
	
	public function admin_menu_fix() {
		global $wp_post_types, $wp_taxonomies, $menu, $submenu;
		$links = array();
		
		$files = $this->get_files();
		foreach( $files as $file ) {
			if( $file['slug'] == 'post' ) {
				$links['edit.php']     = $wp_post_types['post']->labels->menu_name;
				$links['post-new.php'] = $wp_post_types['post']->labels->add_new;
				if( empty( $wp_post_types['post']->taxonomies['category'] ) ) {
					$links['edit-tags.php?taxonomy=category'] = null;
				} else {
					$links['edit-tags.php?taxonomy=category'] = $wp_post_types['post']->taxonomies['category'][0];
				}
				if( empty( $wp_post_types['post']->taxonomies['post_tag'] ) ) {
					$links['edit-tags.php?taxonomy=post_tag'] = null;
				} else {
					$links['edit-tags.php?taxonomy=post_tag'] = $wp_post_types['post']->taxonomies['post_tag'][0];
				}
			}
			if( $file['slug'] == 'page' ) {
				$links['edit.php?post_type=page']     = $wp_post_types['page']->labels->menu_name;
				$links['post-new.php?post_type=page'] = $wp_post_types['page']->labels->add_new;
			}
		}
		
		foreach( $links as $link => $label ) {
			foreach( $menu as $idx => $menu_arr ){
				if( $menu_arr[2] == $link )
					$menu[$idx][0] = $label;
			}
			foreach( $submenu as $menu_link => $submenu_items ) {
				foreach( $submenu_items as $idx => $item ) {
					if( $item[2] == $link ) {
						if( $label )
							$submenu[$menu_link][$idx][0] = $label;
						else
							unset( $submenu[$menu_link][$idx][0] );
					}
				}
			}
		}
	}

	/**
	 * 編集画面でWYSIWYGエディタを増やす
	 * 投稿タイプ設定ファイル内で shibuyaCmsTinyMCESettings
	 */
	/*
	public function tinymce_settings( $settings ) {
		$init = $settings;
		if( @$init['formats'] )
			unset( $init['formats'] );
		if( @$init['external_plugins'] )
			unset( $init['external_plugins'] );
		echo '<script>shibuyaCmsTinyMCESettings = jQuery.extend({ formats:' . $settings['formats'] . ', external_plugins:' . (
					@$settings['external_plugins'] ? $settings['external_plugins'] : '{}'
					) . '}, ' . json_encode( $init ) . ');</script>' . PHP_EOL;
		return $settings; 
	}
	*/
	
	
	/**
	 * 投稿ページの最初で読まれる
	 */
	public function load() {
		global $typenow;
		$files = $this->get_files();
		foreach( $files as $file ) {
			$post_type = $file['slug'];
			//編集画面のWYSIWYGエディタを非表示にする
			if( $typenow == $post_type && @$file['config']['disable_visual_editor'] ) {
				add_filter('user_can_richedit', create_function('', 'return false;'));
			}
		}
	}
	
	
	
	/**
	 * 投稿の画像を合わせるための処理
	 */
	public function get_post_image(){
		$url = ( !empty($_SERVER['HTTPS']) ? 'https://' : 'http://' )
					. $_SERVER['HTTP_HOST']
					. $_SERVER['REQUEST_URI'];
		if( is_user_logged_in() && strstr( $url, admin_url() . '?shibuya-cms-attachment.php' ) ){
			header('Content-Type: application/json');
			
			if( isset($_GET['ids']) ) {
				$result = array();
				foreach( explode(',', $_GET['ids']) as $value ) {
					$result[] = array(
						'id' => $value,
						'name' => basename(wp_get_attachment_url( $value )),
						'thumb_url' => wp_get_attachment_thumb_url( $value ),
						'url' => wp_get_attachment_url( $value ),
					);
				}
				echo json_encode($result);
			} else {
				header('Content-Type: text/plain');
				if( !empty( $_GET['id'] ) ) {
					$file = array(
						'id' => $_GET['id'],
						'name' => basename(wp_get_attachment_url( $_GET['id'] )),
						'thumb_url' => wp_get_attachment_thumb_url( $_GET['id'] ),
						'url' => wp_get_attachment_url( $_GET['id'] ),
					);
				} else {
					$file = array(
						'id' => null,
						'name' => 'dummy',
						'thumb_url' => plugin_dir_url(__FILE__) . 'wp-admin/img/dummy.png',
						'url' => null,
					);
				}
				echo json_encode($file);
			}
			exit;
		}
	}
	
	public function register() {
		global $wp_post_types, $wp_taxonomies;
		
		$files = $this->get_files();
		foreach( $files as $file ) {
			$post_type = $file['slug'];
			
			$ini = $file['config'];
			
			if( $post_type == 'post' || $post_type == 'page' ) {
				$params = (array) get_post_type_object( $post_type );
			} else {
				$params = (array) get_post_type_object( 'post' );
				$keys = array(
							'label',
							'public',
							'hieralchical',
							'show_ui',
							'show_in_menu',
							'show_in_nav_menus',
							'show_in_admin_bar',
							'supports',
							);
				foreach( array_keys( $params ) as $key ) {
					if( !in_array( $key, $keys ) )
						unset( $params[$key] );
				}
			}
			$taxonomies = $metas = array();
			
			foreach( $ini as $key => $value ) {
				//true or false
				if( ! strcasecmp($value, 'true') )
					$value = true;
				if( ! strcasecmp($value, 'false') )
					$value = false;
				
				//tax-とcat-はカテゴリ
				if ( preg_match('/^(?:tax|cat)\-(.*)$/i', $key, $_matches ) ) {
					$taxonomies[ $_matches[1] ] = array( $value, 'category' );
				}
				//tag-はタグ
				elseif ( preg_match('/^tag\-(.*)$/i', $key, $_matches ) ) {
					$taxonomies[ $_matches[1] ] = array( $value, 'tag' );
				}
				//リストに出力する項目
				elseif ( preg_match('/^list\-meta\-(.*)$/i', $key, $_matches ) ) {
					$metas[ $_matches[1] ] = $value;
				}
				//その他のパラメータ
				else {
					$key = strtolower( $key );
					$value = is_numeric( $value )
											? $value - 0
											: $value;
					if( strstr( $key, '.' ) ) {
						$key = explode('.', strtolower($key));
						if( !isset( $params[ $key[0] ] ) )
							$params[ $key[0] ] = array();
						
						if( is_object( $params[ $key[0] ] ) )
							$params[ $key[0] ]->{$key[1]} = $value;
						else
							$params[ $key[0] ][ $key[1] ] = $value;
					} else {
						$params[ $key ] = $value;
					}
				}
			}
			
			foreach( $taxonomies as $key => $value ){
				if( taxonomy_exists( $key ) )
					continue;//unregister_taxonomy( $key );
				register_taxonomy( $key, $post_type, array(
					'label'        => $value[0],
					'public'       => true,
					'show_ui'      => true,
					'hierarchical' => $value[1] == 'category' ? true : false,
					'rewrite'      => array(
						'slug'         => $key,
					),
				) );
			}
			
			
			if( $post_type != 'post' && $post_type != 'page' ) {
				if( ! post_type_exists( $post_type ) ) {
					if( $taxonomies && !isset( $params['taxonomies'] ) ){
						$params['taxonomies'] = array_keys( $taxonomies );
					}
					
					if( $params['supports'] )
						$params['supports'] = explode( ',', $params['supports'] );
					
					if( !isset( $params['has_archive'] ) )
						$params['has_archive'] = true;
					
					register_post_type( $post_type, $params );
				}
			} else {
				$post_type_object = &$wp_post_types[ $post_type ];
				foreach( $params as $key => $value ){
					if( isset( $post_type_object->{$key} ) && is_array( $post_type_object->{$key} ) ) {
						if( ! is_array( $value ) ) {
							$value = array( $value );
						}
						$post_type_object->{$key} = array_merge( $post_type_object->{$key}, $value );
					} else {
						$post_type_object->{$key} = $value;
					}
				}
				$post_type_object->taxonomies = $taxonomies;
				if( $post_type == 'post' ) {
					foreach( array('category', 'post_tag') as $taxonomy ) {
						if( !isset( $taxonomies[$taxonomy] ) 
										&& count( $wp_taxonomies[$taxonomy]->object_type ) == 1
										&& $wp_taxonomies[$taxonomy]->object_type[0] == $post_type ) {
							unset( $wp_taxonomies[$taxonomy] );
						}
					}
				}
			}
		}
		
		add_action( 'admin_menu', array($this, 'admin_menu_fix') );
	}
	
	public function parse_ini($ini) {
		$parsed = array();
		if( preg_match_all( '/([^\:\n]*)[\s]*?\:[\s]*?([^\n]*)/im', $ini, $matches ) ){
			foreach( $matches[1] as $i => $key ){
				$key   = trim( $key );
				$value = trim( $matches[2][$i] );
				if( substr($key, 0, 1) != ';' ) {
					$parsed[$key] = $value;
				}
			}
		}
		return $parsed;
	}
	
	public function wpeditor_init() {
		if( basename($_SERVER['PHP_SELF']) != 'post-new.php' && basename($_SERVER['PHP_SELF']) != 'post.php' )
			return;
		
		if ( ! class_exists( '_WP_Editors', false ) )
			require( ABSPATH . WPINC . '/class-wp-editor.php' );
		add_action( 'admin_print_footer_scripts', array( _WP_Editors, 'editor_js' ), 50 );
		add_action( 'admin_print_footer_scripts', array( _WP_Editors, 'enqueue_scripts' ), 1 );
	}
	
	public function textarea_replace_callback($matches) {
		$textarea = $matches[0];
		if( preg_match( '/data\-richtext=[\'"]true[\'"]/', $textarea ) ) {
			$id = preg_match('/id=([^\s]+)/', $textarea, $match) ? trim($match[1], '"\'') : 'editor-'.uniqid();
			$name = preg_match('/name=([^\s]+)/', $textarea, $match) ? trim($match[1], '"\'') : '';
			return '<'.'?php wp_editor(\'\', \''. $id .'\', array(\'textarea_name\'=>\''. $name .'\')) ?'.'>';
		} else {
			return $textarea;
		}
	}
}

$shibuya_cms = new ShibuyaCMS;
